/*     */ package laser.testcompass;
/*     */ 
/*     */ import android.os.Handler;
/*     */ import it.imwatch.Vector3;
/*     */ import java.io.IOException;
/*     */ 
/*     */ public class KyneticsSensors
/*     */ {
/*  66 */   static int VEC_CODE_RAWACCEL = 0;
/*  67 */   static int VEC_CODE_ACCEL = 1;
/*  68 */   static int VEC_CODE_RAWMAG = 2;
/*  69 */   static int VEC_CODE_RAWMAGMAX = 3;
/*  70 */   static int VEC_CODE_RAWMAGMIN = 4;
/*  71 */   static int VEC_CODE_RAWMAGREF = 5;
/*  72 */   static int VEC_CODE_MAG = 6;
/*  73 */   static int VEC_CODE_ATTITUDE = 7;
/*  74 */   static int VEC_CODE_UNCOMPENSATEDATTITUDE = 8;
/*     */ 
/*  77 */   private I2cNativeLib i2c_jni = new I2cNativeLib();
/*     */ 
/*  83 */   static int DEFAULT_UPDATE_INTERVAL = 100;
/*     */ 
/*  86 */   private Handler handler = new Handler();
/*     */ 
/*  88 */   private Runnable update = null;
/*     */ 
/*  90 */   private int updateInterval = DEFAULT_UPDATE_INTERVAL;
/*     */ 
/*     */   public int init(int readInterval)
/*     */   {
/*  95 */     this.updateInterval = readInterval;
/*  96 */     if (this.updateInterval <= 0)
/*  97 */       this.updateInterval = DEFAULT_UPDATE_INTERVAL;
/*     */     try
/*     */     {
/* 100 */       Runtime.getRuntime().exec("chmod 777 /dev/i2c-0");
/*     */     } catch (IOException e) {
/* 102 */       e.printStackTrace();
/*     */     }
/*     */ 
/* 105 */     int bus = 0;
/* 106 */     int output = this.i2c_jni.openBus(bus);
/*     */ 
/* 109 */     final int ri = readInterval;
/*     */ 
/* 111 */     this.update = new Runnable()
/*     */     {
/*     */       public void run()
/*     */       {
/* 115 */         KyneticsSensors me = KyneticsSensors.this;
/*     */ 
/* 117 */         if (me.isOpen())
/*     */         {
/* 119 */           me.read();
/* 120 */           KyneticsSensors.this.handler.postDelayed(KyneticsSensors.this.update, ri);
/*     */         }
/*     */       }
/*     */     };
/* 125 */     this.handler.postDelayed(this.update, ri);
/*     */ 
/* 127 */     return output;
/*     */   }
/*     */ 
/*     */   public void onPause()
/*     */   {
/* 133 */     this.handler.removeCallbacks(this.update);
/*     */   }
/*     */ 
/*     */   public void onResume() {
/* 137 */     this.handler.postDelayed(this.update, this.updateInterval);
/*     */   }
/*     */ 
/*     */   public void close()
/*     */   {
/* 143 */     this.i2c_jni.closeBus();
/*     */   }
/*     */ 
/*     */   public boolean isOpen()
/*     */   {
/* 148 */     return this.i2c_jni.isOpen();
/*     */   }
/*     */ 
/*     */   public void read()
/*     */   {
/* 155 */     this.i2c_jni.readAccel();
/* 156 */     this.i2c_jni.readMagnet();
/*     */   }
/*     */ 
/*     */   public boolean isAccelCalibrated()
/*     */   {
/* 162 */     return this.i2c_jni.isAccelCalibrated();
/*     */   }
/*     */ 
/*     */   public boolean isAccelCalibrating() {
/* 166 */     return this.i2c_jni.isAccelCalibrating();
/*     */   }
/*     */ 
/*     */   public boolean isMagnetCalibrated()
/*     */   {
/* 172 */     return this.i2c_jni.isMagnetCalibrated();
/*     */   }
/*     */ 
/*     */   public boolean isMagnetCalibrating() {
/* 176 */     return this.i2c_jni.isMagnetCalibrating();
/*     */   }
/*     */ 
/*     */   private Vector3 initVector3(Vector3D vec) {
/* 180 */     Vector3 v = new Vector3(vec.X, vec.Y, vec.Z);
/* 181 */     return v;
/*     */   }
/*     */ 
/*     */   public Vector3 getMagRaw()
/*     */   {
/* 186 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 187 */     this.i2c_jni.getVector3d(VEC_CODE_RAWMAG, vec);
/* 188 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getMagMaxRaw()
/*     */   {
/* 193 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 194 */     this.i2c_jni.getVector3d(VEC_CODE_RAWMAGMAX, vec);
/* 195 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getMagMinRaw() {
/* 199 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 200 */     this.i2c_jni.getVector3d(VEC_CODE_RAWMAGMIN, vec);
/* 201 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getMagRefRaw()
/*     */   {
/* 206 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 207 */     this.i2c_jni.getVector3d(VEC_CODE_RAWMAGREF, vec);
/* 208 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getMag()
/*     */   {
/* 213 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 214 */     this.i2c_jni.getVector3d(VEC_CODE_MAG, vec);
/* 215 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getAccelRaw()
/*     */   {
/* 220 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 221 */     this.i2c_jni.getVector3d(VEC_CODE_RAWACCEL, vec);
/* 222 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getAccel()
/*     */   {
/* 227 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 228 */     this.i2c_jni.getVector3d(VEC_CODE_ACCEL, vec);
/* 229 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getAttitude()
/*     */   {
/* 234 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 235 */     this.i2c_jni.getVector3d(VEC_CODE_ATTITUDE, vec);
/* 236 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public Vector3 getUncompensatedAttitude()
/*     */   {
/* 241 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 242 */     this.i2c_jni.getVector3d(VEC_CODE_UNCOMPENSATEDATTITUDE, vec);
/* 243 */     return initVector3(vec);
/*     */   }
/*     */ 
/*     */   public double getYaw()
/*     */   {
/* 250 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 251 */     this.i2c_jni.getVector3d(VEC_CODE_ATTITUDE, vec);
/* 252 */     return vec.Z;
/*     */   }
/*     */ 
/*     */   public double getUncompensatedYaw()
/*     */   {
/* 257 */     Vector3D vec = new Vector3D(0.0D, 0.0D, 0.0D);
/* 258 */     this.i2c_jni.getVector3d(VEC_CODE_UNCOMPENSATEDATTITUDE, vec);
/* 259 */     return vec.Z;
/*     */   }
/*     */ }

/* Location:
 * Qualified Name:     laser.testcompass.KyneticsSensors
 * JD-Core Version:    0.6.2
 */